/** Copyright (C) 2013 Alexander Mariel

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Autor: Alexander Mariel
 * Trabajo para la asignatura TAIA
 * Practica individual con agentes en la plataforma JADE 
 */
package taia.pli.behaviours;

import jade.core.behaviours.CyclicBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import taia.pli.agents.MusicianAgent;

/**
 * PlayMusic behaviour for LeadAgent
 * 
 * Read PlayMusicBehaviour for doc
 * 
 * @author Alex
 *
 */
@SuppressWarnings("serial")
public class LeadPlayMusicBehaviour extends CyclicBehaviour
{	
	public LeadPlayMusicBehaviour()
	{

	}
	
	@Override
	public void action()
	{
		MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
		ACLMessage msg = myAgent.receive(mt);
		if (msg != null)
		{
			if((msg.getContent()!=null)&&(msg.getContent().equalsIgnoreCase(MetronomeBehaviour.TICK)))
			{
				System.out.println(myAgent.getAID().getLocalName() + ": Recibido mensaje tick");
				((MusicianAgent)myAgent).play();
				
				//Special thingy
				repetirMensaje();
			}
		}
		else
		{
			block();
		}		
	}

	/**
	 * Repeat the tick event
	 * The leader needs to receive it again know when to make changes in the
	 * band direction
	 */
	private void repetirMensaje()
	{
		ACLMessage msgEnviar = new ACLMessage(ACLMessage.INFORM);

    	msgEnviar.setSender(myAgent.getAID());
    	
    	msgEnviar.addReceiver(myAgent.getAID());
    	
    	msgEnviar.setContent(MetronomeBehaviour.TICK + "2");
    	
    	myAgent.send(msgEnviar);
   	}	
}
