/** Copyright (C) 2013 Alexander Mariel

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Autor: Alexander Mariel
 * Trabajo para la asignatura TAIA
 * Practica individual con agentes en la plataforma JADE 
 */
package taia.pli.behaviours;

import jade.core.behaviours.CyclicBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import taia.pli.agents.MusicianAgent;

/**
 * Tells the owning agent to play an audio clip
 * 
 * @author Alex
 *
 */
@SuppressWarnings("serial")
public class PlayMusicBehaviour extends CyclicBehaviour
{
	
	public PlayMusicBehaviour()
	{
		
	}
	
	@Override
	public void action()
	{
		//Received a tick
		MessageTemplate mt = MessageTemplate.and(
				MessageTemplate.MatchPerformative(ACLMessage.INFORM),
				MessageTemplate.MatchContent(MetronomeBehaviour.TICK));
		
		ACLMessage msg = myAgent.receive(mt);
		
		if (msg != null)
		{			
			System.out.println(myAgent.getLocalName() + ": Recibido mensaje tick");
			//Order agent to play a clip
			((MusicianAgent)myAgent).play();
		}
		else
		{
			block();
		}
	}

}
