/** Copyright (C) 2013 Alexander Mariel

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Autor: Alexander Mariel
 * Trabajo para la asignatura TAIA
 * Practica individual con agentes en la plataforma JADE 
 */
package taia.pli.behaviours;

import jade.core.behaviours.CyclicBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import taia.pli.agents.LeadAgent;
import taia.pli.agents.MusicianAgent;

/**
 * Makes the agent able to receive directions form the band leader
 * Directions are seen as orders referring to the next audio clip
 * to play
 * 
 * @author Alex
 *
 */
@SuppressWarnings("serial")
public class ReceiveDirectionsBehaviour extends CyclicBehaviour
{		
	public ReceiveDirectionsBehaviour()
	{
		
	}

	@Override
	public void action()
	{
		//Receive the leaders request to play another thing. If the agent were intelligent
		//(and I had programmed it) it would be able to tell the leader: NO
		MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.REQUEST);
		ACLMessage msg = myAgent.receive(mt);
		if (msg != null)
		{
			if(msg.getContent()!=null)
			{
				//Check if this is direction control message from the leader,
				//if not... ups
				String aux = msg.getContent().split(";")[0];
				if(aux.equalsIgnoreCase(LeadAgent.DIRECTION_MSG));
				{
					try
					{
						//Get number for the next audio clip to play
						((MusicianAgent)myAgent).setNextPartToPlay(Integer.parseInt(msg.getContent().split(";")[1]));
						System.out.println(myAgent.getLocalName() + ": Recibidas nuevas direcciones");
					}
					catch(NumberFormatException e)
					{
						e.printStackTrace();
					}
				}
			}
		}
		else
		{
			block();
		}
	}

}
