/** Copyright (C) 2013 Alexander Mariel

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Autor: Alexander Mariel
 * Trabajo para la asignatura TAIA
 * Practica individual con agentes en la plataforma JADE 
 */
package taia.pli.behaviours.setupPerformance;

import jade.core.AID;
import jade.core.behaviours.OneShotBehaviour;
import taia.pli.utilities.AgentSearcher;
import taia.pli.utilities.DFRegistrar;

/**
 * Tell a lame joke about bassists and their perpetual silence
 * on stage
 * 
 * @author Alex
 *
 */
@SuppressWarnings("serial")
public class TellBassistJokeBehaviour extends OneShotBehaviour
{
	
	public TellBassistJokeBehaviour()
	{

	}
	
	@Override
	public void action()
	{
		AID drummerAID = AgentSearcher.getMyDFS().getAgentByDF(myAgent, DFRegistrar.DRUMS).getFirst();
		AID bassistAID = AgentSearcher.getMyDFS().getAgentByDF(myAgent, DFRegistrar.BASS).getFirst();
		
		System.out.println(drummerAID.getLocalName() + ": Ey," + bassistAID.getLocalName() +
				" comprueba bien que hayas conectado el ampli. Aunque ahora que lo pienso..." +
				"da igual. Nadie te va a oir de todas formas.");
	}

}
